from fastapi_forge.enums import FieldDataType, RelationshipType


test_models = [
    {
        "name": "app_user",
        "fields": [
            {
                "name": "id",
                "type": FieldDataType.UUID,
                "primary_key": True,
                "nullable": False,
                "unique": True,
                "index": True,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "email",
                "type": FieldDataType.STRING,
                "primary_key": False,
                "nullable": False,
                "unique": True,
                "index": True,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "password",
                "type": FieldDataType.STRING,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
        ],
    },
    {
        "name": "restaurant",
        "fields": [
            {
                "name": "id",
                "type": FieldDataType.UUID,
                "primary_key": True,
                "nullable": False,
                "unique": True,
                "index": True,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "name",
                "type": FieldDataType.STRING,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "address",
                "type": FieldDataType.STRING,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "phone_number",
                "type": FieldDataType.STRING,
                "primary_key": False,
                "nullable": True,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
        ],
    },
    {
        "name": "table",
        "fields": [
            {
                "name": "id",
                "type": FieldDataType.UUID,
                "primary_key": True,
                "nullable": False,
                "unique": True,
                "index": True,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "number",
                "type": FieldDataType.INTEGER,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "seats",
                "type": FieldDataType.INTEGER,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "restaurant_id",
                "type": FieldDataType.UUID,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": True,
                "relationship_type": str(RelationshipType.MANY_TO_ONE),
            },
        ],
    },
    {
        "name": "reservation",
        "fields": [
            {
                "name": "id",
                "type": FieldDataType.UUID,
                "primary_key": True,
                "nullable": False,
                "unique": True,
                "index": True,
                "foreign_key": False,
                "relationship_type": None,
            },
            {
                "name": "app_user_id",
                "type": FieldDataType.UUID,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": True,
                "relationship_type": str(RelationshipType.MANY_TO_ONE),
            },
            {
                "name": "restaurant_id",
                "type": FieldDataType.UUID,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": True,
                "relationship_type": str(RelationshipType.MANY_TO_ONE),
            },
            {
                "name": "table_id",
                "type": FieldDataType.UUID,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": True,
                "relationship_type": str(RelationshipType.MANY_TO_ONE),
            },
            {
                "name": "reservation_time",
                "type": FieldDataType.DATETIME,
                "primary_key": False,
                "nullable": False,
                "unique": False,
                "index": False,
                "foreign_key": False,
                "relationship_type": None,
            },
        ],
    },
]
